Description

A class declaration can have a parameter with no default:

class foo($bar)

 Or an undef default:

class foo($bar = undef)

 Both are returned from the proxy as having a nil value for the parameter, however the second case is an actual valid default value for

the parameter.  The class will run correctly if included without specifying this parameter, as it defaults to undef.

Proxy output:

{"foo":{"params":{"bar":null},"module":null,"name":"foo"}}

 Due to the null returned by the proxy, Foreman interprets both cases as it being a required parameter and so forces a value.  If no

value is given, then Foreman returns the parameter in the ENC output but with no value (bar:) which causes Puppet to state:

Error: Received incomplete information - no value provided for parameter bar on node ...

 Better module design would be to use UNSET or similar as a default value anyway.

Associated revisions

Revision dd7018f8 - 03/04/2013 03:00 AM - Dominic Cleal

fixes #2191 - undef in puppet class params is optional

History

#1 - 03/01/2013 08:28 AM - Dominic Cleal

- Status changed from New to Ready For Testing

- Assignee set to Dominic Cleal

- Target version set to 26

https://github.com/theforeman/smart-proxy/pull/66

#2 - 03/04/2013 07:17 AM - Dominic Cleal

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset dd7018f884b35645efe2a24118aa46b37a5484bf.

#3 - 05/10/2013 09:04 AM - Dominic Cleal
https://github.com/theforeman/smart-proxy/pull/66
https://projects.theforeman.org/projects/smart-proxy/repository/7/revisions/dd7018f884b35645efe2a24118aa46b37a5484bf


- Target version changed from 26 to 1.2.0

#4 - 07/10/2018 02:46 PM - Greg Sutcliffe

- Target version deleted (1.2.0)
